PHP_ARG_ENABLE(pbms,
    [Whether to enable the "pbms" extension],
    [  --enable-pbms Enable "pbms" extension support])

# Ask user for path to pbms:.
AC_ARG_WITH(pbms,
    [  --with-pbms=<path> prefix of PBMS installation. e.g. /usr/local or /usr],
    [LIB_PATH=$with_pbms/lib/; INC_PATH=$with_pbms/include;],
    [LIB_PATH=/usr/local/lib/; INC_PATH=/usr/local/include;]
)

PHP_SUBST(PBMS_PREFIX)

PHP_SUBST(PBMS_LIBS)

CPPFLAGS="$CPPFLAGS  -I${INC_PATH} -g -Werror ";
LDFLAGS="$LDFLAGS  -L${LIB_PATH}";

if test $PHP_PBMS != "no"; then
	PHP_SUBST(SAMPLE_SHARED_LIBADD)
	PHP_NEW_EXTENSION(pbms, pbms.c, $ext_shared)
fi

AC_CHECK_HEADERS([pbmslib.h])

AC_SEARCH_LIBS([pbms_get_api_version], [pbmscl mysqlclient], [], [
AC_MSG_ERROR([unable to find the pbms_get_api_version() function])
])

#AC_SEARCH_LIBS will have added the required pbms api lib to LIBS
LDFLAGS="$LDFLAGS $LIBS"