--TEST--
mysqldump with BLOBs
--SKIPIF--
<?php if (($isDrizzleServer == TRUE) || !extension_loaded("PBMS")) print "skip"; ?>
--POST--
--GET--
--FILE--
<?php 
	
	include "pbms_utils.php";

	set_time_limit(300); // Allow lots of time for this test.

	pbms_connect($host, $port, $database)
		or pbms_error_and_die("Could not connect\n");
		
	print "Connected successfully\n";
	
	$mysql = mysql_connect()
		or mysql_error_and_die("Could not connect\n");

	mysql_query("Drop database $database;");
		
	init_php_test_database($mysql, $engine, $database);

	mysql_query("Use $database;")
		or mysql_error_and_die("Use $database; failed\n");
	
	mysql_query("Delete from test1; ")
		or mysql_error_and_die("Delete from test1; Failed: \n" );

	load_backup_test_data();
	
	$pbms_dump_file="php_test_dump.bin";
	if (file_exists($pbms_dump_file))
		unlink($pbms_dump_file);
	
	print "Executing: mysqldump -u <user> --password=<password> --pbms-dump-file $pbms_dump_file <database> > dumptest.sql\n";
	if ( $mysql_passwd == "")
		$passwd_param = "";
	else
		$passwd_param = "--password=$mysql_passwd";
		
	//print "$mysqlServerInst/bin/mysqldump -h $host -u $mysql_user $passwd_param --pbms-dump-file $pbms_dump_file > dumptest.sql\n";
	system("$mysqlServerInst/bin/mysqldump -h $host -u $mysql_user $passwd_param  --pbms-dump-file $pbms_dump_file  $database > dumptest.sql");
	
//die("Stop here.\n");

	// Drop the table before droping the database just to test
	// that the transaction logging handles this correctly since it
	// will probably still have unprocessed transaction records for  the
	// database being dropped.
	mysql_query("Drop table test1; ")
		or mysql_error_and_die("Drop table test1; Failed: \n" );

	mysql_query("Drop database $database;")
		or mysql_error_and_die("Drop database $database failed\n");
		
	init_php_test_database($mysql, $engine, $database);
	
	// create database php_test
	//update php_test.pbms_variable set Value = 'true' where Name = 'Restoring-Dump' 
	// mysql -u root -D php_test -e 'source dumptest.sql;'

	print "Executing: mysql -u <user> --password=<password> -D <database> --pbms-restore $pbms_dump_file -e 'source dumptest.sql;'\n";
	system("$mysqlServerInst/bin/mysql  -h $host -u $mysql_user $passwd_param -D $database  --pbms-restore $pbms_dump_file -e 'source dumptest.sql;'");
	
	print "Verifying backup\n";
	verify_backup_test_data();

	//=================================
	// Do some tests to verify that BLOBs with more than one reference are
	// not duplicated in the dump file.
	mysql_query("insert into test2(c1, c2) values(1, \"A test BLOB\")")
	or mysql_error_and_die("mysql_query() failed");
	
	mysql_query("insert into test2(c1, c2) values(2, \"A second test BLOB\")")
	or mysql_error_and_die("mysql_query() failed");
	
	unlink($pbms_dump_file);
	system("$mysqlServerInst/bin/mysqldump -h $host -u $mysql_user $passwd_param  --pbms-dump-file $pbms_dump_file  $database test2 > dumptest.sql");
	$size = filesize($pbms_dump_file);
	
		// When dumping the BLOBs the dump procedure sould recognize when
	// a BLOB has already been dumped and not do it again. So when a record
	// is added to the table that references a BLOB that is already referenced
	// by another record in the table, the resulting dump file should be the same\// size.
	
	// Add a second reference ta a BLOB already referenced.
	mysql_query("insert into test2(c2) select c2 from test2 where c1 = 1")
	or mysql_error_and_die("mysql_query() failed");
	
	unlink($pbms_dump_file);
	system("$mysqlServerInst/bin/mysqldump -h $host -u $mysql_user $passwd_param  --pbms-dump-file $pbms_dump_file  $database test2 > dumptest.sql");
	$size2 = filesize($pbms_dump_file);

	if ($size != $size2) {
		print "BLOBs are duplicated in the dump file: $size != $size2\n";
	}
	
	unlink($pbms_dump_file);
	unlink("dumptest.sql");
	//=================================
	// Test that when restoring BLOBs that if the BLOB is already in the 
	// database then it is not duplicated.
	
	// Add a records referencing BLOBs also referenced by table test1.
	mysql_query("insert into test2(c2) select c2 from test1 where c1 > 3")
	or mysql_error_and_die("mysql_query() failed");

	$result = mysql_query("select count(*) from pbms_repository;")
	or mysql_error_and_die("Drop database $database failed\n");
	$row = mysql_fetch_row($result);
	mysql_free_result($result);
	$expected_blob_count = $row[0];

	
	if (file_exists("pbms_dump_test1.bin"))
		unlink("pbms_dump_test1.bin");
	
	if (file_exists("pbms_dump_test2.bin"))
		unlink("pbms_dump_test2.bin");
	
	// Dump the to test tables seperately. Because the 2 tables reference
	// some of the same BLOBs the PBMS dump files will both contain some of
	// the same BLOBs.
	system("$mysqlServerInst/bin/mysqldump -h $host -u $mysql_user $passwd_param  --pbms-dump-file pbms_dump_test1.bin  $database test1 > dumptest1.sql");
	system("$mysqlServerInst/bin/mysqldump -h $host -u $mysql_user $passwd_param  --pbms-dump-file pbms_dump_test2.bin  $database test2 > dumptest2.sql");

	mysql_query("Drop database $database;")
	or mysql_error_and_die("Drop database $database failed\n");
	
	init_php_test_database($mysql, $engine, $database);
	
	// Restore the 2 dumped tables. When restoring the second table PBMS should
	// recognize the duplicate BLOBs and not duplicate them in the repository.
	system("$mysqlServerInst/bin/mysql  -h $host -u $mysql_user $passwd_param -D $database  --pbms-restore pbms_dump_test1.bin -e 'source dumptest1.sql;'");
	system("$mysqlServerInst/bin/mysql  -h $host -u $mysql_user $passwd_param -D $database  --pbms-restore pbms_dump_test2.bin -e 'source dumptest2.sql;'");
	
	$result = mysql_query("select count(*) from pbms_repository;")
	or mysql_error_and_die("Drop database $database failed\n");
	$row = mysql_fetch_row($result);
	mysql_free_result($result);
	$blob_count = $row[0];

	if ($expected_blob_count != $blob_count)
		print "Duplicate BLOBs after table restore. $expected_blob_count != $blob_count\n";
	
	unlink("dumptest1.sql");
	unlink("dumptest2.sql");
	unlink("pbms_dump_test1.bin");
	unlink("pbms_dump_test2.bin");
	
	print "mysqldump with BLOBs done.\n";
		
	// Closing connection
	pbms_close();
	mysql_close($mysql);
?>
--EXPECT--
Connected successfully
Executing: mysqldump -u <user> --password=<password> --pbms-dump-file php_test_dump.bin <database> > dumptest.sql
Executing: mysql -u <user> --password=<password> -D <database> --pbms-restore php_test_dump.bin -e 'source dumptest.sql;'
Verifying backup
mysqldump with BLOBs done.

