--TEST--
Test the pbms_metadata system table.
--SKIPIF--
<?php if (!extension_loaded("PBMS")) print "skip"; ?>
--POST--
--GET--
--FILE--
<?php 
	include "pbms_utils.php";
	
	print "Test the pbms_metadata system table.\n";
	pbms_connect($host, $port, $database)
		or pbms_error_and_die("Could not connect");

	$mysql = mysql_connect()
		or mysql_error_and_die("Could not connect");
	
	$query = "Drop database IF EXISTS $database;";
	if (mysql_query($query) == FALSE) {
		mysql_error_and_die("$query Failed\n");
	}


	init_php_test_database($mysql, $engine, $database);

	$query = "use $database;";
	if (mysql_query($query) == FALSE) {
		mysql_error_and_die("$query Failed\n");
	}

	mysql_query("Delete from test1; ")
		or mysql_error_and_die("Query Failed: $query");

	$my_blob = "A baby BLOB.";
	resister_my_metadata($mysql, "Header1");
	resister_my_metadata($mysql, "Header2");
	
	print "Known headers.\n";
	$query = "select * from pbms_metadata_header";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	while ($line = mysql_fetch_array($result)) {
		print "$line[0]\n";
	}


	//----------------------
	$blob_num = 1;
	pbms_add_metadata("content-type", "text $blob_num");
	pbms_add_metadata("Header1", "A header1 $blob_num");
	pbms_add_metadata("Header2", "A header2 $blob_num");
	pbms_add_metadata("Header3", "Unregistered header, not saved $blob_num");	
	$blob_ref = pbms_put_data($my_blob)
		or pbms_error_and_die("pbms_put_data() error");


	$blob_ref1 = pbms_put_data("A new BLOB")
		or pbms_error_and_die("pbms_write_stream() error");

	$query = sprintf ("Insert into test1(c1, c2) values(%d, '%s');", $blob_num, $blob_ref1) ;
	if (mysql_query($query) == FALSE) {
		mysql_error_and_die("Query Failed: $query\n");
	}

	//----------------------
	$blob_num = 2;
	// BLOB 2 will have the same headers as BLOB 1 except for Header1.
	pbms_clear_metadata("Header1");
	pbms_add_metadata("Header1", "A different header1 $blob_num");
	$blob_ref = pbms_put_data($my_blob)
		or pbms_error_and_die("pbms_put_data() error");


	$blob_ref1 = pbms_put_data("A new BLOB")
		or pbms_error_and_die("pbms_write_stream() error");

	$query = sprintf ("Insert into test1(c1, c2) values(%d, '%s');", $blob_num, $blob_ref1) ;
	if (mysql_query($query) == FALSE) {
		mysql_error_and_die("Query Failed: $query\n");
	}


	//----------------------
	$blob_num = 3;
	// BLOB 3 will only have the "Content-Type" header.
	pbms_clear_metadata(); // Clear all headers
	pbms_add_metadata("Content-Type", "text/blob $blob_num");
	$blob_ref = pbms_put_data($my_blob)
		or pbms_error_and_die("pbms_put_data() error");


	$blob_ref1 = pbms_put_data("A new BLOB")
		or pbms_error_and_die("pbms_write_stream() error");

	$query = sprintf ("Insert into test1(c1, c2) values(%d, '%s');", $blob_num, $blob_ref1) ;
	if (mysql_query($query) == FALSE) {
		mysql_error_and_die("Query Failed: $query\n");
	}

	//----------------------
	//----------------------
	// Because of the temp references created when the BLOB was first
	// uploaded, all the meta data will appear duplicated in the pbms_metadata
	// table. The duplicates will disappear when the temp reference timeout
	// expires. 
	print "Dump the pbms_metadata table.\n";
	$query = "select name, value from pbms_metadata order by name, value;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	if (mysql_num_rows($result) != 14)
		die("Unexpected number of rows: $query\n");
		
	while ($line = mysql_fetch_array($result)) {
		print "$line[0] = '$line[1]'\n";
	}
	mysql_free_result($result);
	//----------------------
	
	$blob_num = 1;
	print "Select the headers for BLOB $blob_num.\n";
	$query = "select c2 from test1 where c1 = $blob_num;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	$row = mysql_fetch_array($result)
		or mysql_error_and_die("No row was returned: $query");
		
	$ref = trim($row[0]);
	mysql_free_result($result);

	$query = sprintf("select m.name, m.value from pbms_metadata m, pbms_reference r 
		where r.Blob_url = '%s' 
			and r.blob_id = m.blob_id 
			order by name;", $ref) ;
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");

	while ($line = mysql_fetch_array($result)) {
		print "$line[0] = '$line[1]'\n";
	}

	pbms_get_info($ref)
		or pbms_error_and_die("pbms_get_info($ref) Failed:");
		
	$content_type = pbms_get_metadata_value("Content-Type");
	if ($content_type == FALSE) {
		pbms_error_and_die("pbms_get_metadata_value(Content-Type) Failed: ");	
	}

	print "Content-Type: $content_type \n";
	//----------------------
	$blob_num = 2;
	print "Select the headers for BLOB $blob_num.\n";
	$query = "select c2 from test1 where c1 = $blob_num;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	$row = mysql_fetch_array($result)
		or mysql_error_and_die("No row was returned: $query");
		
	$ref = trim($row[0]);
	mysql_free_result($result);
	
	$query = sprintf("select m.name, m.value from pbms_metadata m, pbms_reference r 
		where r.Blob_url = '%s' 
			and r.blob_id = m.blob_id 
			order by name;", $ref) ;
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	while ($line = mysql_fetch_array($result)) {
		print "$line[0] = '$line[1]'\n";
	}
	
	
	pbms_get_info($ref)
		or pbms_error_and_die("pbms_get_info($ref) Failed:");
		
	$content_type = pbms_get_metadata_value("Content-Type");
	if ($content_type == FALSE) {
		pbms_error_and_die("pbms_get_metadata_value(Content-Type) Failed: ");	
	}

	print "Content-Type: $content_type \n";
	//----------------------
	$blob_num = 3;
	print "Select the headers for BLOB $blob_num.\n";
	$query = "select c2 from test1 where c1 = $blob_num;";
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	$row = mysql_fetch_array($result)
		or mysql_error_and_die("No row was returned: $query");
		
	$ref = trim($row[0]);
	mysql_free_result($result);
	
	$query = sprintf("select m.name, m.value from pbms_metadata m, pbms_reference r 
		where r.Blob_url = '%s' 
			and r.blob_id = m.blob_id 
			order by name;", $ref) ;
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	while ($line = mysql_fetch_array($result)) {
		print "$line[0] = '$line[1]'\n";
	}
	
	
	pbms_get_info($ref)
		or pbms_error_and_die("pbms_get_info($ref) Failed:");
		
	$content_type = pbms_get_metadata_value("Content-Type");
	if ($content_type == FALSE) {
		pbms_error_and_die("pbms_get_metadata_value(Content-Type) Failed: ");	
	}

	print "Content-Type: $content_type \n";


?>
--EXPECT--
Test the pbms_metadata system table.
Known headers.
Header2
Header1
Content-Type
Dump the pbms_metadata table.
content-type = 'text 1'
content-type = 'text 1'
content-type = 'text 1'
content-type = 'text 1'
Content-Type = 'text/blob 3'
Content-Type = 'text/blob 3'
Header1 = 'A different header1 2'
Header1 = 'A different header1 2'
Header1 = 'A header1 1'
Header1 = 'A header1 1'
Header2 = 'A header2 1'
Header2 = 'A header2 1'
Header2 = 'A header2 1'
Header2 = 'A header2 1'
Select the headers for BLOB 1.
content-type = 'text 1'
Header1 = 'A header1 1'
Header2 = 'A header2 1'
Content-Type: text 1 
Select the headers for BLOB 2.
content-type = 'text 1'
Header1 = 'A different header1 2'
Header2 = 'A header2 1'
Content-Type: text 1 
Select the headers for BLOB 3.
Content-Type = 'text/blob 3'
Content-Type: text/blob 3 
