--TEST--
Test PBMS persistent connections.
--SKIPIF--
<?php if (!extension_loaded("PBMS")) print "skip"; ?>
--POST--
--GET--
--FILE--
<?php 
	include "custom_settings.ini";

	$con_dump=0;
	print "PBMS Persistent Connection test\n";

	$pbc1 = pbms_connect()
		or die("Could not connect");
		
	
	 print "One non pool connection opened\n";
	 pbms_print_con_info();
	 print "----------------------\n\n";
		
	/*  */
	$pbc2 = pbms_pconnect()
		or die("Could not connect");
	 
	 print "Check that a call to pbms_pconnect() opens another non pool connection because pool size is 0.\n";
	 pbms_print_con_info();
	 print "----------------------\n\n";
		
	 	 
	 
	 // Close connection should really close the connection. 
	 pbms_close($pbc2); unset($pbc2);
	 print "Close a non pooled connection\n";
	 pbms_print_con_info();
	 print "----------------------\n\n";
		
	 
	pbms_connection_pool_size(2);  // This will create a pool of 2 persistent connections.
	
	
	
		/* Open a persistent connection. */
	$pbc2 = pbms_pconnect()
		or die("Could not connect");
		
	 print "Open a pool connection.\n";
	 pbms_print_con_info();
	 print "----------------------\n\n";
		
	 
	 // Close connection should not really close the connection. 
	 pbms_close($pbc2); unset($pbc2);
		
	 print "Close a pool connection, should not really close the connection.\n";
	 pbms_print_con_info();
	 print "----------------------\n\n";
	 
	// Opening a connection should reuse the old pool connection.
	$pbc2 = pbms_pconnect()
		or die("Could not connect");
		
	 print "Opening a connection should reuse the old pool connection.\n";
	 pbms_print_con_info();
	 print "----------------------\n\n";
	 
	 // Open 2 more connections and then close 1 to see that the 2 connection pool size is observerd.	 
	$pbc3 = pbms_pconnect()
		or die("Could not connect");
	 
	$pbc4 = pbms_pconnect() // Pool size is exceeded so this open a normal connection.
		or die("Could not connect");
		
	 print "Open 1 Pool and one non pool connection.\n";
	 pbms_print_con_info();
	 print "----------------------\n\n";

	 // Close connection should not really close the connection because it is in a pool. 
	 pbms_close($pbc2); unset($pbc2);
		
	 print "Close a pool connection.\n\n";
	 pbms_print_con_info();
	 print "----------------------\n\n";
	 
	 pbms_close($pbc3); unset($pbc3);// The connection should remain open in the pool.
	
	
	 print "Close a pool connection, The connection should remain open in the pool.\n";
	 pbms_print_con_info();
	 print "----------------------\n\n";
	
	pbms_close($pbc4);  unset($pbc4);// The connection should be closed because the pool size was exceeded when the connection was made.
		
	 print "Close a non pooled connection.\n";$con_dump++;
	 pbms_print_con_info();
	 print "----------------------\n\n";

	// 
	$pbc4 = pbms_pconnect() 
		or die("Could not connect");
		
	 print "Open 1 Pool connection.\n";
	 pbms_print_con_info();
	 print "----------------------\n\n";
	 

	 pbms_connection_pool_size(0);  
		
	 print "Setting the pool size to 0 should close all unused connections.\n";
	 pbms_print_con_info();
	 print "----------------------\n";
	
	 pbms_close($pbc4);unset($pbc4);
		
	 print "The connection should be really closed this time because the pool size is zero.\n";
	 pbms_print_con_info();
	 print "----------------------\n";
	 
	 pbms_connection_pool_size(2);  

	$pbc2 = pbms_pconnect()
		or die("Could not connect");
	 
	$pbc3 = pbms_pconnect()
		or die("Could not connect");
	 
	$pbc4 = pbms_pconnect()
		or die("Could not connect");
	 
		
	 print "Open 3 connections 2 pool one non pool because of pool size limit.\n";
	 pbms_print_con_info();
	 print "----------------------\n";

	 pbms_close($pbc4);unset($pbc4);// The connection should be really closed because the pool size is 2.
		
	 print "Closing a non pool connection.\n";
	 pbms_print_con_info();
	 print "----------------------\n";
	 
	 		 
	
	// Connect with a different database, this should open a new connection and create a new pool.
	$pbc4 = pbms_pconnect($host, $port, "XXXXX")
		or die("Could not connect");
	 
		
	 print "Opening a connection in a new pool.\n";
	 pbms_print_con_info();
	 print "----------------------\n";
	 
	 pbms_close($pbc3);unset($pbc3);
		
	 print "Closing a connection in pool 2. Connection should remain open.\n";
	 pbms_print_con_info();
	 print "----------------------\n";
	 
	// Connect as a different database again, this should NOT open a new connection.
	$pbc5 = pbms_pconnect($host, $port, "XXXXX")
		or die("Could not connect");
		
	 print "Connect to pool 1 again. Should open a new connection.\n";
	 pbms_print_con_info();
	 print "----------------------\n";
	 
	 // 
	 pbms_close($pbc5);unset($pbc5);
		
	 print "Close connection should NOT really close the connection.\n";
	 pbms_print_con_info();
	 print "----------------------\n";
	 
	// 
	$pbc5 = pbms_connect($host, $port, "XXXXX")
		or die("Could not connect");
		
	 print "Opening a non pool connection that should use a pool connection anyway.\n";
	 pbms_print_con_info();
	 print "----------------------\n";
	 

	 // 
	 pbms_close($pbc5);unset($pbc5);
		
	 print "Close connection should NOT really close the connection.\n";
	 pbms_print_con_info();
	 print "----------------------\n";
	 

	 pbms_connection_pool_size(1);  // Should close 1 connection in the default connection pool.
		
	 print "Reset pool size, should close non active connections in excess of pool size.\n";$con_dump++;
	 pbms_print_con_info();
	 print "----------------------\n";


	$pbc2 = pbms_pconnect()
		or die("Could not connect");
		
	 print "Should create a non pool connection.\n";
	 pbms_print_con_info();
	 print "----------------------\n";


	 pbms_connection_pool_size(2);  
	 
		
	 print "Reset pool size to 2, no connection change expected.\n";$con_dump++;
	 pbms_print_con_info();
	 print "----------------------\n";
	
	$pbc1 = 0;
	$pbc2 = 0;
	$pbc3 = 0;
	$pbc4 = 0;
	$pbc5 = 0;
?>
<?php 
	
	print ">>>>>>>>>>>> The start of section 2 <<<<<<<<<<<<<<<<<<<<<<\n";
		
	 print "All non pool connections should have been closed. And all pool connections marked as inactive.\n";
	 pbms_print_con_info();
	 print "----------------------\n";

	$pbc1 = pbms_connect()
		or die("Could not connect");
		
			
	 print "Use a connection in connection pool 2.\n";
	 pbms_print_con_info();
	 print "----------------------\n";

	/* Check that another call to pbms_connect() uses the old persistent connection. */
	$pbc2 = pbms_connect()
		or die("Could not connect");
		
	 print "Use an other connection in connection pool 2.\n";
	 pbms_print_con_info();
	 print "----------------------\n";
	 
	 
	// Connect to a different database again, this should NOT open a new connection.
	$pbc4 = pbms_connect($host, $port, "XXXXX")
		or die("Could not connect");
	 
		
	 print "Use a connection in connection pool 1.\n";
	 pbms_print_con_info();
	 print "----------------------\n";
	 
	$pbc1 = 0;
	$pbc2 = 0;
	$pbc3 = 0;
	$pbc4 = 0;
	$pbc5 = 0;
	 
	 print "All connections should be inactive.\n";
	 pbms_print_con_info();
	 print "----------------------\n";
	 
	 pbms_connection_pool_size(0); 
	 print "All connections should be closed.\n";
	 pbms_print_con_info();
	 print "----------------------\n";
	  

	 
?>	
--EXPECT--
PBMS Persistent Connection test
One non pool connection opened
Connection total: 1, Pool size: 0
Non Pool Connections: 1
----------------------

Check that a call to pbms_pconnect() opens another non pool connection because pool size is 0.
Connection total: 2, Pool size: 0
Non Pool Connections: 2
----------------------

Close a non pooled connection
Connection total: 1, Pool size: 0
Non Pool Connections: 1
----------------------

Open a pool connection.
Connection total: 2, Pool size: 2
Pool: 1, Connected: 1, Active: 1 
Non Pool Connections: 1
----------------------

Close a pool connection, should not really close the connection.
Connection total: 2, Pool size: 2
Pool: 1, Connected: 1, Active: 0 
Non Pool Connections: 1
----------------------

Opening a connection should reuse the old pool connection.
Connection total: 2, Pool size: 2
Pool: 1, Connected: 1, Active: 1 
Non Pool Connections: 1
----------------------

Open 1 Pool and one non pool connection.
Connection total: 4, Pool size: 2
Pool: 1, Connected: 2, Active: 2 
Non Pool Connections: 2
----------------------

Close a pool connection.

Connection total: 4, Pool size: 2
Pool: 1, Connected: 2, Active: 1 
Non Pool Connections: 2
----------------------

Close a pool connection, The connection should remain open in the pool.
Connection total: 4, Pool size: 2
Pool: 1, Connected: 2, Active: 0 
Non Pool Connections: 2
----------------------

Close a non pooled connection.
Connection total: 3, Pool size: 2
Pool: 1, Connected: 2, Active: 0 
Non Pool Connections: 1
----------------------

Open 1 Pool connection.
Connection total: 3, Pool size: 2
Pool: 1, Connected: 2, Active: 1 
Non Pool Connections: 1
----------------------

Setting the pool size to 0 should close all unused connections.
Connection total: 2, Pool size: 0
Pool: 1, Connected: 1, Active: 1 
Non Pool Connections: 1
----------------------
The connection should be really closed this time because the pool size is zero.
Connection total: 1, Pool size: 0
Pool: 1, Connected: 0, Active: 0 
Non Pool Connections: 1
----------------------
Open 3 connections 2 pool one non pool because of pool size limit.
Connection total: 4, Pool size: 2
Pool: 1, Connected: 2, Active: 2 
Non Pool Connections: 2
----------------------
Closing a non pool connection.
Connection total: 3, Pool size: 2
Pool: 1, Connected: 2, Active: 2 
Non Pool Connections: 1
----------------------
Opening a connection in a new pool.
Connection total: 4, Pool size: 2
Pool: 1, Connected: 1, Active: 1 
Pool: 2, Connected: 2, Active: 2 
Non Pool Connections: 1
----------------------
Closing a connection in pool 2. Connection should remain open.
Connection total: 4, Pool size: 2
Pool: 1, Connected: 1, Active: 1 
Pool: 2, Connected: 2, Active: 1 
Non Pool Connections: 1
----------------------
Connect to pool 1 again. Should open a new connection.
Connection total: 5, Pool size: 2
Pool: 1, Connected: 2, Active: 2 
Pool: 2, Connected: 2, Active: 1 
Non Pool Connections: 1
----------------------
Close connection should NOT really close the connection.
Connection total: 5, Pool size: 2
Pool: 1, Connected: 2, Active: 1 
Pool: 2, Connected: 2, Active: 1 
Non Pool Connections: 1
----------------------
Opening a non pool connection that should use a pool connection anyway.
Connection total: 5, Pool size: 2
Pool: 1, Connected: 2, Active: 2 
Pool: 2, Connected: 2, Active: 1 
Non Pool Connections: 1
----------------------
Close connection should NOT really close the connection.
Connection total: 5, Pool size: 2
Pool: 1, Connected: 2, Active: 1 
Pool: 2, Connected: 2, Active: 1 
Non Pool Connections: 1
----------------------
Reset pool size, should close non active connections in excess of pool size.
Connection total: 3, Pool size: 1
Pool: 1, Connected: 1, Active: 1 
Pool: 2, Connected: 1, Active: 1 
Non Pool Connections: 1
----------------------
Should create a non pool connection.
Connection total: 4, Pool size: 1
Pool: 1, Connected: 1, Active: 1 
Pool: 2, Connected: 1, Active: 0 
Non Pool Connections: 2
----------------------
Reset pool size to 2, no connection change expected.
Connection total: 4, Pool size: 2
Pool: 1, Connected: 1, Active: 1 
Pool: 2, Connected: 1, Active: 0 
Non Pool Connections: 2
----------------------
>>>>>>>>>>>> The start of section 2 <<<<<<<<<<<<<<<<<<<<<<
All non pool connections should have been closed. And all pool connections marked as inactive.
Connection total: 3, Pool size: 2
Pool: 1, Connected: 1, Active: 0 
Pool: 2, Connected: 1, Active: 0 
Non Pool Connections: 1
----------------------
Use a connection in connection pool 2.
Connection total: 2, Pool size: 2
Pool: 1, Connected: 1, Active: 0 
Pool: 2, Connected: 1, Active: 1 
Non Pool Connections: 0
----------------------
Use an other connection in connection pool 2.
Connection total: 3, Pool size: 2
Pool: 1, Connected: 1, Active: 0 
Pool: 2, Connected: 1, Active: 1 
Non Pool Connections: 1
----------------------
Use a connection in connection pool 1.
Connection total: 3, Pool size: 2
Pool: 1, Connected: 1, Active: 1 
Pool: 2, Connected: 1, Active: 1 
Non Pool Connections: 1
----------------------
All connections should be inactive.
Connection total: 2, Pool size: 2
Pool: 1, Connected: 1, Active: 1 
Pool: 2, Connected: 1, Active: 0 
Non Pool Connections: 0
----------------------
All connections should be closed.
Connection total: 1, Pool size: 0
Pool: 1, Connected: 1, Active: 1 
Pool: 2, Connected: 0, Active: 0 
Non Pool Connections: 0
----------------------
	
