--TEST--
Test PBMS insert of a BLOB URL from a BLOB in a different database.
--SKIPIF--
<?php if (!extension_loaded("PBMS")) print "skip"; ?>
--POST--
--GET--
--FILE--
<?php 
	include "pbms_utils.php";

	// Connecting, selecting database
	$pbms = pbms_connect($host, $port, $database)
		or pbms_error_and_die("Could not connect");
		

	$mysql = mysql_connect()
		or mysql_error_and_die("Could not connect");

	print "Connected successfully\n";
	
	// To avoid propblems with BLOB counting start with 
	// new databases.
	$database2 = "$database" . "_2";
	mysql_query("Drop database $database;");
	mysql_query("Drop database $database2;");
	
	init_php_test_database($mysql, $engine, $database);

	$database2 = "$database" . "_2";
	init_php_test_database($mysql, $engine, $database2);
	
	mysql_query("Use $database;")
	or mysql_error_and_die("Use $database failed");
	
	mysql_query("Delete from test1; ")
		or mysql_error_and_die("Query Failed: $query");


	mysql_query("Delete from $database2.test1; ")
		or mysql_error_and_die("Query Failed: $query");

	$data[0] = "A BLOB";
	$data[1] = "This is a some what larger BLOB, but still very tiny by BLOB standards.";
	$data[2] = build_a_char_blob(1024);
	$data[3] = build_a_char_blob(100 * 1024);
	$cnt = 1;
	foreach ($data as $val) {
	
		$query = sprintf ("Insert into test1(c1, c2) values( %d, '%s');", $cnt, $val) ;
		mysql_query($query)
			or mysql_error_and_die("Query Failed: $query");
			
		$cnt++;
	}

	// Insert the BLOB URLs from one database into another.
	// This should copy the BLOB from one database to the other. 
	$query = "Insert into $database2.test1 (select * from test1);" ;
	mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");


	// Now check that the BLOBs are correct.
	mysql_query("Use $database2;")
	or mysql_error_and_die("Use $database2 failed");

	$result = mysql_query("select c1, c2 from test1 order by c1; ")
		or mysql_error_and_die("Query Failed: $query");

	$cnt = 0;
	while ($row = mysql_fetch_assoc($result)) {
		//printf("row(%d): %d, %s\n",  $cnt, $row['c1'], $row['c2']);
		$output = pbms_get_data($row['c2'], $pbms)
			or pbms_error_and_die("pbms_get_data() error");

		//$output .= chr(0);
		if (strcmp($output, $data[$cnt])) {
			printf("Data mismatch in row %d lengths: %d, %d\n", $cnt, strlen($data[$cnt]), strlen($output));
			//printf("Original: -->%s<--\n", $data[$cnt]);
			//printf("Returned: -->%s<--\n", $output);
		}
		
		
		// Test stream access:
		$fh = fopen("phptest.blob", "w+")
			or die("fopen() error");
			
		pbms_write_stream($fh, $row['c2'], $pbms)
			or pbms_error_and_die("pbms_write_stream() error");
		
		rewind($fh);
		$stream_output = "";
		while (!feof($fh))
			$stream_output .= fgets($fh, 4096);
			
		if (strcmp($stream_output, $data[$cnt])) {
			printf("Stream Data mismatch in row %d lengths: %d, %d\n", $cnt, strlen($data[$cnt]), strlen($stream_output));
			//printf("Original: -->%s<--\n", $data[$cnt]);
			//printf("Returned: -->%s<--\n", $output);
		}
		
		fclose($fh);
		unlink("phptest.blob");

		$cnt++;
	}
	

	// Now that the BLOBs are in the new database selecting the URL
	// from the original database and inserting it into the new database
	// should not result in the BLOB being copied agaian but it should
	// recognize the BLOB is already in the database and just add another 
	// reference to it.
	
	$query = "select count(*) from pbms_repository;" ;
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
		
	$row = mysql_fetch_row($result);
	$blob_count = $row[0];
		
	$query = "Insert into test1(c1, c2) (select 101, c2 from $database.test1 where c1 = 1);" ;
	mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");

	$query = "select count(*) from pbms_repository;" ;
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
		
	$row = mysql_fetch_row($result);
	
	if ( $row[0] != $blob_count) {
		die("Unexpected BLOB count ($row[0] != $blob_count), BLOB was copied when it should not have been.");
	}

	// Check the refernce count.
	$query = "select rep.blob_id, rep.Reference_count from pbms_repository rep, pbms_reference ref, test1 t 
			where t.c1 = 1 AND t.c2 = ref.Blob_url AND ref.blob_id = rep.blob_id;" ;
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	$row = mysql_fetch_assoc($result);
	if ( $row['Reference_count'] != 2) {
		$cnt = $row['Reference_count'];
		die("Unexpected BLOB reference count $cnt != 2).");
	}
	
	// Check that the BLOB references point to the same BLOB.
	$blob_id = $row['blob_id'];
	$query = "select ref.blob_id from pbms_reference ref, test1 t 
			where t.c1 = 101 AND t.c2 = ref.Blob_url ;" ;
	$result = mysql_query($query)
		or mysql_error_and_die("Query Failed: $query");
	
	$row = mysql_fetch_assoc($result);

	if ( $row['blob_id'] != $blob_id) {
		$id = $row['blob_id'];
		die("BLOB references do not point to the same BLOB: $id != $blob_id).");
	}
	
	print "Inter database BLOB URL insert done.\n";
?>
--EXPECT--
Connected successfully
Inter database BLOB URL insert done.
	
